View Issue Details

IDProjectCategoryView StatusLast Update
0011138CentOS-7[All Projects] generalpublic2018-04-17 08:00
Reporterhunter86_bg 
PriorityhighSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Product Version7.2.1511 
Target VersionFixed in Version 
Summary0011138: Bridge device cannot get ip from dhcp when connected to teamed device (no link available). After restart of network - works
Description2 Ethernet devices are configured in a team (activebackup) and a network bridge is connected to the team device.

After a reboot (NetworkManager.service is masked) the network.service reports that the team device is up , but there is no link for the bridge. After "ystemctl restart network" the bridge receives it's ip.
When the bridge is set to static ip - it always works.
Steps To ReproduceConnect a bridge device to a team device(activebackup runner)with masked NetworkManager.service. Static IPs in the configs (commented) always work.
Additional InformationConfig of ifcfg-team0-eth0:
=================================
AME=team0-eth0
UUID=d2cb2d59-0d97-46ef-b5d9-255341a059a2
DEVICE=eth0
ONBOOT=yes
TEAM_MASTER=nm-team
DEVICETYPE=TeamPort
=================================
Config of ifcfg-team0-eth1:
NAME=team0-eth1
UUID=00cec63f-58aa-49d4-8c1b-f4004c0b6c7e
DEVICE=eth1
ONBOOT=yes
TEAM_MASTER=nm-team
DEVICETYPE=TeamPort
==================================
Config of the team device (ifcfg-team0):
DEVICE=nm-team
TEAM_CONFIG="{\"runner\":{\"name\":\"activebackup\"}}"
DEVICETYPE=Team
#BOOTPROTO=dhcp
#DEFROUTE=yes
#PEERDNS=yes
#PEERROUTES=yes
#IPV4_FAILURE_FATAL=no
#IPV6INIT=yes
#IPV6_AUTOCONF=yes
#IPV6_DEFROUTE=yes
#IPV6_PEERDNS=yes
#IPV6_PEERROUTES=yes
#IPV6_FAILURE_FATAL=no
NAME=team0
UUID=e28b33c4-d175-4c36-9f3d-6b4c6d24453f
ONBOOT=yes
BRIDGE=nm-bridge
==================================
Config of the bridge (ifcfg-br0):
EVICE=nm-bridge
STP=yes
BRIDGING_OPTS=priority=32768
TYPE=Bridge
#BOOTPROTO=static
BOOTPROTO=dhcp
DEFROUTE=yes
PEERDNS=yes
PEERROUTES=yes
IPV4_FAILURE_FATAL=no
IPV6INIT=yes
IPV6_AUTOCONF=yes
IPV6_DEFROUTE=yes
IPV6_PEERDNS=yes
IPV6_PEERROUTES=yes
IPV6_FAILURE_FATAL=no
NAME=br0
UUID=25f33bab-f987-4ccf-b49b-a072957c2fe3
ONBOOT=yes
#IPADDR0=192.168.100.151
#PREFIX0=24
====================================
TagsNo tags attached.
abrt_hash
URL

Activities

hunter86_bg

hunter86_bg

2016-07-07 07:16

reporter  

journalctl-network.service_unix.txt (3,392 bytes)
-- Logs begin at Wed 2016-07-06 13:00:06 EEST, end at Wed 2016-07-06 13:07:01 EEST. --
Jul 06 13:00:38 server1.example.com systemd[1]: Starting LSB: Bring up/down networking...
Jul 06 13:00:38 server1.example.com network[996]: Bringing up loopback interface:  [  OK  ]
Jul 06 13:00:40 server1.example.com network[996]: Bringing up interface team0:  [  OK  ]
Jul 06 13:00:40 server1.example.com network[996]: Bringing up interface team0-eth0:  [  OK  ]
Jul 06 13:00:41 server1.example.com network[996]: Bringing up interface team0-eth1:  [  OK  ]
Jul 06 13:00:41 server1.example.com network[996]: Bringing up interface br0:
Jul 06 13:00:48 server1.example.com network[996]: Determining IP information for nm-bridge... failed; no link present.  Check cable?
Jul 06 13:00:48 server1.example.com network[996]: [FAILED]
Jul 06 13:00:48 server1.example.com systemd[1]: network.service: control process exited, code=exited status=1
Jul 06 13:00:48 server1.example.com systemd[1]: Failed to start LSB: Bring up/down networking.
Jul 06 13:00:48 server1.example.com systemd[1]: Unit network.service entered failed state.
Jul 06 13:00:48 server1.example.com systemd[1]: network.service failed.
Jul 06 13:06:56 server1.example.com systemd[1]: Starting LSB: Bring up/down networking...
Jul 06 13:06:56 server1.example.com network[2796]: Bringing up loopback interface:  [  OK  ]
Jul 06 13:06:56 server1.example.com network[2796]: Bringing up interface team0:  RTNETLINK answers: File exists
Jul 06 13:06:56 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:06:57 server1.example.com network[2796]: device nm-team is already a member of a bridge; can't enslave it to bridge nm-bridge.
Jul 06 13:06:57 server1.example.com network[2796]: [  OK  ]
Jul 06 13:06:57 server1.example.com network[2796]: Bringing up interface team0-eth0:  RTNETLINK answers: File exists
Jul 06 13:06:57 server1.example.com network[2796]: [  OK  ]
Jul 06 13:06:57 server1.example.com network[2796]: Bringing up interface team0-eth1:  RTNETLINK answers: File exists
Jul 06 13:06:57 server1.example.com network[2796]: [  OK  ]
Jul 06 13:06:57 server1.example.com network[2796]: Bringing up interface br0:
Jul 06 13:06:57 server1.example.com dhclient[3251]: DHCPREQUEST on nm-bridge to 255.255.255.255 port 67 (xid=0x3c9dd4c3)
Jul 06 13:06:57 server1.example.com dhclient[3251]: DHCPACK from 192.168.100.1 (xid=0x3c9dd4c3)
Jul 06 13:07:00 server1.example.com network[2796]: Determining IP information for nm-bridge... done.
Jul 06 13:07:01 server1.example.com network[2796]: [  OK  ]
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com network[2796]: RTNETLINK answers: File exists
Jul 06 13:07:01 server1.example.com systemd[1]: Started LSB: Bring up/down networking.
N3WWN

N3WWN

2016-09-28 21:10

reporter   ~0027612

I was able to replicate this issue and have resolved it with a patch that I will attach momentarily.

The issue was that, if DELAY is not set in ifcfg-br0, the init script would not wait for STP to complete startup before attempting to obtain an IP via DHCP.

DELAY is now set by obtaining the forward_delay directly from the interface if DELAY is not otherwise defined.

Let me know if you have any questions or concerns about this patch.

-Rich Alloway (RogueWave)
N3WWN

N3WWN

2016-09-28 21:10

reporter  

initscripts-9.49.30-1.el7_2.3_bugs.centos.org_11138.patch (3,402 bytes)
From 072f0b0e6fe3bd805236689601a1ec4295aacdda Mon Sep 17 00:00:00 2001
From: Rich Alloway <richard.alloway@roguewave.com>
Date: Thu, 25 Aug 2016 10:07:08 -0400
Subject: [PATCH] check in initscripts-9.49.30 patch which resolves issue
 reported in https://bugs.centos.org/view.php?id=11138

---
 ...scripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch | 12 ++++++++++++
 src/rpmbuild/SPECS/initscripts.spec                          |  7 ++++++-
 2 files changed, 18 insertions(+), 1 deletion(-)
 create mode 100644 src/rpmbuild/SOURCES/initscripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch

diff --git a/src/rpmbuild/SOURCES/initscripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch b/src/rpmbuild/SOURCES/initscripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch
new file mode 100644
index 0000000..a9b812a
--- /dev/null
+++ b/src/rpmbuild/SOURCES/initscripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch
@@ -0,0 +1,12 @@
+diff -ur initscripts-9.49.30.orig/sysconfig/network-scripts/ifup-eth initscripts-9.49.30/sysconfig/network-scripts/ifup-eth
+--- initscripts-9.49.30.orig/sysconfig/network-scripts/ifup-eth	2015-09-16 07:51:07.000000000 -0400
++++ initscripts-9.49.30/sysconfig/network-scripts/ifup-eth	2016-08-25 09:55:37.609000000 -0400
+@@ -55,6 +55,8 @@
+ 		/usr/sbin/brctl addbr -- ${DEVICE} || exit 1
+       fi
+       [ -n "${DELAY}" ] && /usr/sbin/brctl setfd -- ${DEVICE} ${DELAY}
++      # If DELAY is not set, obtain forward_delay from interface (and convert centiseconds to seconds)
++      [ -z "${DELAY}" ] && DELAY=$(expr $(cat /sys/devices/virtual/net/${DEVICE}/bridge/forward_delay) \/ 100)
+       [ -n "${STP}" ] && /usr/sbin/brctl stp -- ${DEVICE} ${STP}
+       [ -n "${PRIO}" ] && /usr/sbin/brctl setbridgeprio ${DEVICE} ${PRIO}
+       [ -n "${AGEING}" ] && /usr/sbin/brctl setageing ${DEVICE} ${AGEING}
diff --git a/src/rpmbuild/SPECS/initscripts.spec b/src/rpmbuild/SPECS/initscripts.spec
index 19e2102..3968d18 100644
--- a/src/rpmbuild/SPECS/initscripts.spec
+++ b/src/rpmbuild/SPECS/initscripts.spec
@@ -4,7 +4,7 @@ Version: 9.49.30
 # ppp-watch is GPLv2+, everything else is GPLv2
 License: GPLv2 and GPLv2+
 Group: System Environment/Base
-Release: 1%{?dist}.3
+Release: 1%{?dist}.3_rw001
 URL: http://fedorahosted.org/releases/i/n/initscripts/
 Source: http://fedorahosted.org/releases/i/n/initscripts/initscripts-%{version}.tar.bz2
 BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
@@ -38,6 +38,7 @@ Provides: /sbin/service
 Patch1: 0001-autorelabel-call-dracut-initramfs-restore-before-for.patch
 Patch2: 0001-autorelabel-turn-quota-off-before-relabeling.patch
 Patch3: 0001-source_config-tell-NetworkManger-to-load-ifcfg-file-.patch
+Patch4: initscripts-9.49.30-rw001-resolve-bugs_centos_org-11138.patch
 
 %description
 The initscripts package contains basic system scripts used
@@ -60,6 +61,7 @@ Currently, this consists of various memory checking code.
 %patch1 -p1
 %patch2 -p1
 %patch3 -p1
+%patch4 -p1
 
 %build
 make
@@ -223,6 +225,9 @@ rm -rf $RPM_BUILD_ROOT
 /etc/profile.d/debug*
 
 %changelog
+* Thu Aug 25 2016 Rich Alloway <richard.alloway@roguewave.com> - 9.49.30-1.3_rw001
+- Resolve issue reported in https://bugs.centos.org/view.php?id=11138
+
 * Thu Jun 16 2016 Lukáš Nykrýn <lnykryn@redhat.com> - 9.49.30-1.3
 - source_config: tell NetworkManger to load ifcfg file even for NM_CONTROLLED=no
 
-- 
1.8.3.1

hunter86_bg

hunter86_bg

2016-09-29 12:06

reporter   ~0027614

Will it be provided in the next version of the package ,as I'm not allowed to manually patch the scripts?
Is it affecting RHEL 7 also ? Should I report it there , too - as I have a mixed environment of CentOS/RHEL 7 servers ?
N3WWN

N3WWN

2016-09-29 15:21

reporter   ~0027622

Yes, RHEL 7 will exhibit the same behavior. The file which the patch modifies is included in the source tarball used to build the RPM, so RHEL and CentOS would be impacted equally.

I can open a ticket with RedHat referencing this ticket, or, if you'd prefer, you can open the ticket and I'll update it with my patch.

If the patch is accepted by RedHat, the fix should be included in a future package release, but it is anyone's guess as to when that may be.

Feel free to shoot me an email (richard.alloway@roguewave.com) if you want to discuss getting a RPM.

Thanks!

-Rich Alloway (RogueWave)
hunter86_bg

hunter86_bg

2016-09-29 15:59

reporter   ~0027625

Feel free to open a ticket to Red Hat, in order to help anyone else in the same situation.It seems our subscription with Red Hat is "self-support" and this type of subscription does not bring support on any Operating System related issue.

I'll modify the "ifcfg-br0" to impose a DELAY ,as I'm not allowed to manually patch the "initscripts" in order to easily recognize patched from non-patched version.

The best option would be Red Hat to review the patch ,that you have proposed, so they can add it in a future package.
N3WWN

N3WWN

2016-09-29 18:58

reporter   ~0027626

I have created a new bug report in the RedHat Bugzilla referencing this ticket and supplied my patch: https://bugzilla.redhat.com/show_bug.cgi?id=1380496
hunter86_bg

hunter86_bg

2018-04-17 03:52

reporter   ~0031622

Can someone close this bug, as it's resolved in Red Hat now (RHBA-2018:0983).

Issue History

Date Modified Username Field Change
2016-07-07 07:16 hunter86_bg New Issue
2016-07-07 07:16 hunter86_bg File Added: journalctl-network.service_unix.txt
2016-09-28 21:10 N3WWN Note Added: 0027612
2016-09-28 21:10 N3WWN File Added: initscripts-9.49.30-1.el7_2.3_bugs.centos.org_11138.patch
2016-09-29 12:06 hunter86_bg Note Added: 0027614
2016-09-29 15:21 N3WWN Note Added: 0027622
2016-09-29 15:59 hunter86_bg Note Added: 0027625
2016-09-29 18:58 N3WWN Note Added: 0027626
2018-04-17 03:52 hunter86_bg Note Added: 0031622
2018-04-17 08:00 TrevorH Status new => closed
2018-04-17 08:00 TrevorH Resolution open => fixed